﻿enyo.kind({
    name: "enyo.GpxFile",
    kind: enyo.Control,
    events: {
        onFilePluginReady: ""
    },

    components: [
        { kind: "enyo.FilePlugin", name: "file", onPluginReady: "onPluginReady" }
    ],

    _filePluginReady: false,
    firstWrite: true,
    filename: "",

    header: '<?xml version="1.0" encoding="UTF-8" standalone="no" ?>\n' +
	        '<gpx xmlns="http://www.topografix.com/GPX/1/1" creator="Yandex.Maps for WebOS" version="1.1" ' +
            'xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" ' +
            'xsi:schemaLocation="http://www.topografix.com/GPX/1/1 http://www.topografix.com/GPX/1/1/gpx.xsd">\n' +
            '<trk>\n',
    footer: '</trkseg>\n</trk>\n</gpx>',

    onPluginReady: function (inSender, inEvent) {
        this._filePluginReady = true;

        // create the filename on start and do not change it
        this.filename = "/media/internal/gpx_" + this.formatDate() + ".log";
        this.header = this.header + '<name>Track_' + this.formatDate() + '</name>\n<trkseg>\n';

        this.doFilePluginReady(inEvent);
    },

    // generates a new gpx filename
    // and will be used on next write
    // infact, created new file
    newFile: function () {
        this.filename = "/media/internal/gpx_" + this.formatDate() + ".log";
    },

    // writes string to file
    writeGpx: function (message) {
        if (this._filePluginReady) {
            if (this.firstWrite) {
                this.firstWrite = false;
                this.$.file.writeLine(this.filename, this.header);
                this.$.file.writeLine(this.filename, message + "\n");
            }
            else {
                this.$.file.writeLine(this.filename, message);
            }
        }
        else {
            window.setTimeout(enyo.bind(this, "writeGpx", message), 500);
        }
    },

    stopGpx: function () {
        if (this._filePluginReady) {
            this.$.file.writeLine(this.filename, this.footer);
        }
        else {
            window.setTimeout(enyo.bind(this, "stopGpx", message), 500);
        }
    },

    writeLog: function (message) {
        if (this._filePluginReady) {
            this.$.file.log("/media/internal/yandexmaps.log", message);
        }
        else {
            window.setTimeout(enyo.bind(this, "writeLog", message), 500);
        }
    },

    exist: function (filename) {
        if (this._filePluginReady) {
            return this.$.file.exist(filename);
        }
        return false;
    },

    // formates date to "YYYY_MM_DD_HH-MM-SS"
    formatDate: function () {
        var d = new Date();
        var yyyy = d.getFullYear().toString();
        var mm = (d.getMonth() + 1).toString(); // getMonth() is zero-based
        var dd = d.getDate().toString();
        var hh = d.getHours();
        var min = d.getMinutes();
        var sec = d.getSeconds();
        return yyyy + '_' + (mm[1] ? mm : "0" + mm[0]) + "_" + (dd[1] ? dd : "0" + dd[0]) +
            "_" + hh + '-' + min + '-' + (sec[1] ? sec : "0" + sec); // padding
    }
});