﻿enyo.kind({
    name: "enyo.CacheSource",
    kind: enyo.Component,
    components: [
        { name: "downloader",
            kind: "PalmService",
            service: "palm://com.palm.downloadmanager/",
            method: "download",
            onResponse: "gotResponse",
            subscribe: true
        },
    ],

    file: null, // reference on file plugin

    cacheDirectory: "/media/internal/yandexmaps/cache/",
    cacheYandex: "yandex/",
    cacheGoogle: "google/",
    cacheOSM: "osm/",

    setPlugin: function() {
        this.file = enyo.application.filePlugin;
        console.log("file cache is READY");
    },

    get: function (url) {

        var layerPrefix = this.cacheYandex;
        if (url.indexOf('google') > 0)
            layerPrefix = this.cacheGoogle;
        else if (url.indexOf('openstreetmap') > 0)
            layerPrefix = this.cacheOSM;

        var filename = null;
        switch (layerPrefix) {
            case this.cacheYandex:
                filename = url.split('?')[1].replace(/&/g, '') + ".png";       
                break;
            case this.cacheOSM:
                filename = url.substr(url.indexOf('openstreetmap.org/')+18).replace(/&/g, '').replace(/\//g, '_');
                break;
            default:
                filename =  url.substr(url.lastIndexOf('/')).replace(/&/g, '').replace(/\//g, '_') + ".png";
                break;
        }

        // do not cache traffic tiles
        if (filename.indexOf('l=trf') >= 0)
            return url;

        var fullname = this.cacheDirectory + layerPrefix + filename;
        //console.log("file: " + fullname);
        if (this.file) {
            var fileExist = this.file.exist(fullname);
            //console.log("exist: " + fileExist);
            if (!fileExist) {
                //console.log("downloading file: " + filename);
                this.$.downloader.call({
                    target: url,
                    mime: "image/png",
                    targetDir: this.cacheDirectory + layerPrefix,
                    targetFilename: filename,
                    keepFilenameOnRedirect: false,
                    canHandlePause: false,
                    subscribe: true
                });
            } else {
                // return from file cache
                //console.log("get from cache: " + fullname);
                return fullname;
            }
        }
        else {
            //console.log("file plugin is not ready");
        }
        return url;
    },

    gotResponse: function (inSender, inResponse) {
        //console.log('down: ' + enyo.json.stringify(inResponse));
    },
})