﻿enyo.kind({
    name: "enyo.MainView",
    kind: enyo.VFlexBox,
    components: [
    // services
	    {name: "openApp", kind: "PalmService", service: "palm://com.palm.applicationManager/", method: "open" },
        { name: "blueGps", kind: "enyo.SPPGPS",
            onDeviceFound: "blueGpsDeviceFound",
            onChooseDevice: "blueGpsChooseDevice",
            onDeviceConnected: "blueGpsDeviceConnected",
            onDeviceDisconnected: "blueGpsDeviceDisconnected",
            onLocationFound: "blueGpsLocationFound",
            onSignalLost: "blueGpsSignalLost"
        },
        { name: "googleGps", kind: "enyo.GoogleGPS", onLocated: "googleGpsLocationFound", onFailed: "googleGpsFailed" },

    // controls
        {kind: "AppMenu", components: [
                { caption: "About", onclick: "onMenuAbout" },
                { caption: "Settings", onclick: "onMenuSettings" },
                { caption: "Exit", onclick: "onMenuExit" }
            ]
    },
        { kind: "Pane", flex: 1, transitionKind: "enyo.transitions.Simple",
            components: [
            { name: "mainView", kind: enyo.VFlexBox, components: [
                { name: "dlgChooseBlueGps", kind: "enyo.DialogChooseBluetoothGps", onChoosen: "choosenDone" },
		        { name: "slidingPane", kind: "SlidingPane", flex: 1,
		            components: [
			        { name: "left", width: "200px", components: [
				        { kind: "VFlexBox", flex: 1, components: [
					        { kind: "Item", layoutKind: "HFlexLayout", align: "left", components: [
							        { content: $L("Traffic"), flex: 1, style: "padding-left: 10px;padding-right: 10px;" },
                                    { name: "tglTraffic", kind: "ToggleButton", onLabel: "on", offLabel: "off", onChange: "buttonToggleTraffic" }
					        ]
					        },
					        { name: "roadEvents", kind: "Item", layoutKind: "HFlexLayout", align: "left", showing: false, components: [
							        { content: $L("Accidents"), flex: 1, style: "padding-left: 10px;padding-right: 10px;" },
                                    { name: "btnAccidents", kind: "ToggleButton", onLabel: "on", offLabel: "off", onChange: "buttonToggleAccidents" }
					        ]
					        },
                            { name: "divider", kind: "Divider", caption: "Layers", showing: true },
					        { name: "list", kind: "VirtualList", flex: 1, onSetupRow: "listSetupRow", components: [
						        { kind: "Item", layoutKind: "HFlexLayout", align: "left", onclick: "itemClick", components: [
							            { name: "name", flex: 1, style: "padding-left: 10px;padding-right: 10px;" },
                                        { name: "btnOn", kind: "CheckBox", caption: "on" }
						        ]
						        }
					        ]
					        },
				        ]
				        }
			        ]
			        },
			        { name: "right", flex: 1, dragAnywhere: false, onResize: "slidingResize", components: [
				        { kind: "VFlexBox", flex: 1, components: [
					        { name: "map", kind: "enyo.YandexMap", showing: true,
					            mapType: "yandex#map", zoom: 10,
					            onConnectionAvail: "connectionAvail", onConnectionFailure: "connectionFailure",
					            onCenterChanged: "mapCenterChanged"
					        },
                            { tag: "div", name: "ymapsdiv", style: "width:100%; height:100%; background-color:#f8f8f8;",
                                components: [
                                    { name: "noconn", kind: "Image", src: "images/no-wifi.png", showing: false,
                                        width: "110px", height: "98px", className: "centeredImage"
                                    },
                            ]
                            },
                            { name: "btnGps", kind: "Image", src: "images/status_bar_inactive.png",
                                className: "btnGps", width: "48px", height: "48px", onclick: "btnGpsClick"
                            },
                            { name: "btnRecTrack", kind: "Image", src: "images/btnRecordTrack.png", showing: false,
                                className: "btnRecTrack", width: "48px", height: "48px", onclick: "btnRecTrackClick"
                            },
                            { name: "btnTraffic", kind: "Image", src: "images/trafficOff.png",
                                className: "btnTraffic", width: "48px", height: "48px", onclick: "btnTrafficClick"
                            },
                            { name: "btnZoomIn", kind: "Image", src: "images/btnZoomIn.png",
                                className: "btnZoomIn", width: "48px", height: "48px", onclick: "btnZoomClick"
                            },
                            { name: "lblZoom", className: "zoom-lb", content: "10" },
                            { name: "btnZoomOut", kind: "Image", src: "images/btnZoomOut.png",
                                className: "btnZoomOut", width: "48px", height: "48px", onclick: "btnZoomClick"
                            },
                            { name: "speedMeter", kind: "SpeedMeter" }
				        ]
				        },
				        { kind: "Toolbar", className: "enyo-toolbar-light", components: [
					        { kind: "GrabButton" },
                            { kind: "Image", src: "images/where_am_i.png", onclick: "findmeClick" }
				        ]
				        }
			        ]
			        }
                ]
		        }
		    ]
            },
            { name: "sview", kind: "SettingsView", onBack: "onSettingBack", onLoaded: "onSettingsLoaded" }
            ]
        },
        { name: "aboutDialog", kind: "ModalDialog", caption: $L("О программе"), width: "450px", components: [
		    { kind: "HFlexBox", components: [
	            { components: [
		            { kind: "Image", src: 'images/about_icon.png', style: "margin-left: 20px;margin-right: 10px" }
			    ]
	            },
			    { components: [
			        { content: $L("Яндекс.Карты для WebOS"), className: 'enyo-text-subheader enyo-text-ellipsis' },
	                { content: $L("Версия " + enyo.fetchAppInfo().version), className: 'enyo-text-ellipsis enyo-subtext' }
			    ]
			    }
	        ]
		    },
            { layoutKind: "HFlexLayout", pack: "center", components: [
                { kind: "Button", caption: "OK", width: "120px", onclick: "okClick" },
            ]
            }
        ]
        },

        { kind: "Sound", preload: false },
        { kind: "ApplicationEvents", onUnload: "applicationUnload" },

    // error happens on planes switch - main plane is not restored (empty screen displayed)
    // somethings wrong with 2 files usage
    // 2 classes can't get access with one plugin??
    //{ kind: "enyo.LogFile", name: "logFile" },
        {kind: "enyo.GpxFile", name: "file", onFilePluginReady: "onFilePluginReady" },
        { kind: enyo.CacheSource, name: "fileCache" },
	],
    menuItems: [
		{ name: "Yandex", id: "yandex" },
        { name: "Google", id: "google" },
        { name: "OSM", id: "osm" }
	],

    layerSelected: "yandex",
    filePluginReady: false,

    // =================================== File Plugin ========================================

    applicationUnload: function (inSender, inEvent) {
        if (this.$.map) {
            this.$.map.destroy();
            this.$.map = null;
            delete this.$.map;
        }
    },

    writeLog: function (message) {
        console.log(message);
        this.$.file.writeLog(message);
    },

    onFilePluginReady: function (inResponse) {
        this.filePluginReady = true;
        enyo.application.filePlugin = this.$.file;
        this.$.fileCache.setPlugin();
        this.showMap();
    },

    getFileCache: function () {
        return this.$.fileCache;
    },

    // =================================== Sound ===============================================

    playQueue: [], // FIFO play queue
    playing: false,
    playSound: function (filename) {
        if (!this.playing) {

            this.playing = true;

            if (filename != undefined) {
                this.$.sound.setSrc(filename);
            }
            else {
                if (this.playQueue.length > 0) {
                    filename = this.playQueue.shift();
                    this.$.sound.setSrc(filename);
                }
            }

            if (filename != undefined) {
                console.log('playing: ' + filename);
                this.$.sound.play();
                this.$.sound.audio.addEventListener('ended', enyo.bind(this, function () { this.playing = false; }), false);

                // run wait for next item in queue
                if (this.playQueue.length > 0) {
                    setTimeout(enyo.bind(this, "playSound"), 400);
                }
            }
        }
        else {
            // something playing now, so
            // add to play queue
            if (filename != undefined) {
                this.playQueue.push(filename);
            }
            // wait while prev sound played
            // simulating thread.Sleep()
            setTimeout(enyo.bind(this, "playSound"), 400);
        }
    },

    // =========================================================================================

    rendered: function () {
        this.inherited(arguments);
        this.writeLog("Yandex.Maps started");
        //this.showMap();
    },

    destroy: function () {
        this.turnOffGps();
        console.log('destroy called');
    },

    unloadHandler: function () {
        /* unloadHandler() - Disconnect SPP Device
        * Called when application is dismissed/closed
        */
        //make sure to disconnect from the SPP SERVICE!
        this.turnOffGps();
    },

    getSettings: function () {
        return this.$.sview.$.settings;
    },

    // ======================================== GPS handling ==================================================

    gpsRecordingTrack: false,
    btnRecTrackClick: function () {
        this.gpsRecordingTrack = !this.gpsRecordingTrack;
        if (this.gpsRecordingTrack)
            this.$.btnRecTrack.setSrc("images/btnRecordTrack_pressed.png");
        else
            this.$.btnRecTrack.setSrc("images/btnRecordTrack.png");
    },

    enableRecordTrack: function () {
        this.$.btnRecTrack.show();
    },

    stopRecordTrack: function () {
        this.gpsRecordingTrack = false;
        this.$.btnRecTrack.hide();
    },

    gpsTurnedOn: false,
    btnGpsClick: function () {
        console.log("btnGps click");
        if (!this.gpsTurnedOn) {
            this.turnOnGps();
            this.startAnimation();
        }
        else {
            this.turnOffGps();
            this.stopAnimation();
        }
    },

    turnOnGps: function () {
        this.$.map.gpsPositionHide();
        switch (this.getSettings().selectedGpsType) {
            case "google":
                this.$.googleGps.getPosition();
                break;
            case "internal":
                this.enableRecordTrack();
                this.$.googleGps.startTracking();
                this.$.speedMeter.show();
                break;
            case "external":
                this.enableRecordTrack();
                this.$.blueGps.connect();
                this.$.speedMeter.show();
                break;
        }

        this.gpsTurnedOn = true;
    },

    turnOffGps: function () {
        this.$.map.gpsPositionHide();
        this.$.btnGps.setSrc("images/status_bar_inactive.png");

        switch (this.getSettings().selectedGpsType) {
            case "google":
                break;
            case "internal":
                this.$.googleGps.stopTracking();
                this.$.speedMeter.hide();
                this.stopRecordTrack();
                break;
            case "external":
                this.$.speedMeter.hide();
                this.stopRecordTrack();
                this.$.blueGps.disconnect();
                break;
        }
        this.gpsTurnedOn = false;
        this.gpsLocked = false;
    },

    step: 1,
    gpsIsAnimated: false,
    startAnimation: function () {
        this.gpsIsAnimated = true;
        this.step = 1;
        window.setTimeout(enyo.hitch(this, "stepAnimation"), 500);
    },
    stopAnimation: function () {
        this.gpsIsAnimated = false;
    },
    stepAnimation: function () {
        if (this.gpsIsAnimated) {
            this.step++;
            if (this.step > 6) this.step = 1;
            this.$.btnGps.setSrc("images/status_bar_active_" + this.step + ".png");
            window.setTimeout(enyo.hitch(this, "stepAnimation"), 500);
        }
        else {
            if (this.gpsTurnedOn)
                this.$.btnGps.setSrc("images/status_bar_active.png");
            else
                this.$.btnGps.setSrc("images/status_bar_inactive.png");
        }
    },

    // ====================================== BLUETOOTH GPS ===============================================

    retryCount: 5,
    // Bluetooth GPS event handlers
    blueGpsDeviceFound: function (inSender, deviceInfo) {
        this.writeLog('blueGpsDeviceFound: ' + enyo.json.stringify(deviceInfo));
        enyo.windows.addBannerMessage("Bluetooth GPS found: " + deviceInfo.name, "{}", "{}", "notification");
    },
    blueGpsChooseDevice: function (inSender, deviceList) {
        this.writeLog('blueGpsChooseDevice: ' + enyo.json.stringify(deviceInfo));
        if (deviceList !== null) {
            if (this.gpsTurnedOn)
                this.$.dlgChooseBlueGps.show(deviceList);
        }
    },
    blueGpsDeviceConnected: function (inSender, deviceInfo) {
        this.writeLog('blueGpsDeviceConnected: ' + enyo.json.stringify(deviceInfo));
        enyo.windows.addBannerMessage("Bluetooth GPS " + deviceInfo.name + " connected!", "{}", "{}", "notification");
    },
    blueGpsDeviceDisconnected: function () {
        this.writeLog('blueGpsDeviceDisconnected');
        enyo.windows.addBannerMessage("Bluetooth GPS disconnected.", "{}", "{}", "notification");

        if (this.retryTry == null)
            this.retryTry = this.retryCount;
        else
            this.retryTry -= 1;

        if (this.retryTry == 0) return;

        if (this.gpsTurnedOn)
            this.$.blueGps.connect();
    },
    blueGpsLocationFound: function (inSender, lat, lon) {
        this.writeLog('blueGpsLocationFound: ' + lat + '/' + lon);

        this.gpsIsAnimated = false;
        this.$.btnGps.setSrc("images/status_bar_active.png");

        var flat = parseFloat(lat.substr(0, lat.length - 1));
        var flon = parseFloat(lon.substr(0, lon.length - 1));

        this.addGpxTrackPoint(flat, flon);
        this.$.map.gpsPosition(flat, flon, false, this.gpsRecordingTrack);
        this.$.map.pantoPositionQuick();
    },
    blueGpsSignalLost: function () {
        this.writeLog("blueGpsSignalLost");
    },

    choosenDone: function (inSender, address) {
        if (this.gpsTurnedOn)
            this.$.blueGps.subscribeDeviceService(address);
    },

    // ================================== GPS: Google & Internal ==================================================

    gpsLocked: false,

    googleGpsLocationFound: function (inSender, inResponse) {
        this.writeLog("gps location services [success]: " + enyo.json.stringify(inResponse));

        if (this.gpsTurnedOn) {

            if (this.getSettings().selectedGpsType == "google") {
                this.stopAnimation();
                this.turnOffGps();

                if (inResponse.errorCode == 0) {
                    this.$.map.gpsPosition(parseFloat(inResponse.latitude), parseFloat(inResponse.longitude), true, false);
                    this.$.map.pantoPosition();
                }
                else {
                    enyo.windows.addBannerMessage("Location is not found", "{}", "{}", "notification");
                }
            }

            if (this.getSettings().selectedGpsType == "internal") {
                if (inResponse.errorCode == 0) {

                    if (!this.gpsLocked) {
                        if (inResponse.horizAccuracy != undefined && inResponse.horizAccuracy >= 0) {
                            this.gpsLocked = true;
                            this.stopAnimation();
                            this.playSound(Resources.RU.voice.woman.Ira.gpsConnected);
                        }
                    }
                    else {
                        if (inResponse.horizAccuracy != undefined) {

                            // There is a poor gps handling in webOS
                            // so if horizAccuracy == -1
                            // we think that signal is lost (may be just poor strength?)
                            // otherwise signal accepted and show position
                            if (inResponse.horizAccuracy < 0) {
                                this.gpsLocked = false;
                                this.$.speedMeter.setValue(0);
                                this.playSound(Resources.RU.voice.woman.Ira.gpsMissing);
                            }
                            else {
                                this.$.speedMeter.setValue(parseFloat(inResponse.velocity));
                                var lat = parseFloat(inResponse.latitude);
                                var lon = parseFloat(inResponse.longitude);

                                this.addGpxTrackPoint(lat, lon);
                                this.$.map.gpsPosition(lat, lon, false, this.gpsRecordingTrack);

                                // TODO: driven from UI
                                this.$.map.pantoPositionQuick();
                            }
                        }
                    }
                }
                else if (inResponse.errorCode > 0) {
                    enyo.windows.addBannerMessage("Location is not found", "{}", "{}", "notification");
                    this.stopAnimation();
                    this.turnOffGps();
                }
                else {
                    enyo.windows.addBannerMessage("Waiting while GPS locks location", "{}", "{}", "notification");
                }
            }
        }
    },
    googleGpsFailed: function (inSender, inResponse) {
        this.writeLog("gps location services [failed]: " + enyo.json.stringify(inResponse));

        if (this.gpsTurnedOn) {
            this.stopAnimation();
            this.turnOffGps();
            enyo.windows.addBannerMessage("Your current location is unavailable", "{}", "{}", "notification");
        }
    },

    addGpxTrackPoint: function (lat, lon) {
        var dt = new Date();

        if (this.gpsRecordingTrack) {
            // create new gpx file
            // if recording is turned on
            if (this.prevRecordingState == undefined || this.prevRecordingState == false) {
                this.$.file.newFile();
            }

            // TODO: driven from UI
            this.$.file.writeGpx('<trkpt lat="' + lat + '" lon="' + lon + '">' +
                                            '<time>' + dt.getFullYear() + '-' + (dt.getMonth() + 1) + '-' + dt.getDate() +
                                            'T' + dt.getHours() + ':' + dt.getMinutes() + ':' + dt.getSeconds() + 'Z</time>' +
                                            '</trkpt>');
        }
        this.prevRecordingState = this.gpsRecordingTrack;
    },

    // ======================================= Toolbar Menu =========================================

    findmeClick: function () {
        if (!this.$.map.pantoPosition())
            enyo.windows.addBannerMessage("Your current location is unavailable", "{}", "{}", "notification");
    },

    btnZoomClick: function (inSender) {

        var z = this.$.map.getZoom();
        if (inSender.name == "btnZoomIn") { z += 1 } else { z -= 1 }
        this.$.map.setZoom(z);
        this.updateZoomLabel(z);

        var settings = this.getSettings();
        if (settings.restorePosition) {
            console.log('saving position [btn click], zoom: ' + z);
            settings.restorePositionZoom = z;
            settings.save();
        }
    },

    updateZoomLabel: function (value) {
        if (value < 10) {
            this.$.lblZoom.applyStyle("margin-left", "-40px");
        } else if (value == 11) {
            this.$.lblZoom.applyStyle("margin-left", "-43px");
        } else {
            this.$.lblZoom.applyStyle("margin-left", "-45px");
        }
        this.$.lblZoom.setContent(value);
    },

    btnTrafficClick: function () {

        this.doToggleTraffic();
        this.updateTrafficControls();
    },

    updateTrafficControls: function () {
        this.$.tglTraffic.setState(this.$.map.shownTraffic);
        if (this.$.map.shownTraffic)
            this.$.btnTraffic.setSrc("images/trafficOn.png");
        else
            this.$.btnTraffic.setSrc("images/trafficOff.png");

        this.$.map.shownTraffic = this.$.tglTraffic.getState();
    },

    adjustControls: function () {
        var width = this.$.btnTraffic.parent.hasNode().offsetWidth;        
        console.log('adjustControls running: ' + width);
        this.$.btnTraffic.applyStyle("left", width + "px");
        this.$.lblZoom.applyStyle("left", width + "px");
        this.$.btnZoomIn.applyStyle("left", width + "px");
        this.$.btnZoomOut.applyStyle("left", width + "px");
    },

    // ======================================= MAIN Menu ===========================================

    onMenuAbout: function () {
        this.openAboutDialog();
    },
    onMenuSettings: function () {
        this.$.pane.selectView(this.$.sview);
    },
    onSettingBack: function () {
        this.$.pane.selectView(this.$.mainView);
    },
    onMenuExit: function () {
        window.close();
    },
    openAboutDialog: function () {
        this.$.aboutDialog.openAtCenter();
    },

    okClick: function () {
        this.$.aboutDialog.close();
    },

    // ================================== Connection ===========================================

    connected: false,
    connectionFailure: function () {
        if (this.connected) {
            //            enyo.windows.addBannerMessage("No internet connection is currently available", "{}", "{}", "notification");
            console.log("connectionFailure");
            //            this.$.noconn.show();
            this.connected = false;
        }
    },

    connectionAvail: function () {
        console.log("connectionAvail");
        this.connected = true;
        //        this.$.noconn.hide();
        //        this.showMap();
    },

    showMap: function () {
        if (!this.$.map.hasMap()) {
            if (this.settingsLoaded && this.filePluginReady)
                this.$.map.renderMap();
        }
    },
    mapCenterChanged: function (sender, e) {

        var settings = this.getSettings();

        if (settings.restorePosition) {
            settings.restorePositionZoom = this.$.map.getZoom();
            settings.restorePositionLat = parseFloat(e[0]);
            settings.restorePositionLong = parseFloat(e[1]);
            console.log('saving position, location: ' + settings.restorePositionLat + '/' + settings.restorePositionLong);
            settings.save();
        }
    },

    // ================================= LOADING SETTINGS ===========================================
    // settings values
    parameter: "",
    parameterValue: "",
    settingsLoaded: false,

    onSettingsLoaded: function (inSender, inResponse) {
        var sets = this.getSettings();

        console.log("restoring settings");

        if (sets.restoreLayerSelection) {
            var rlayer = sets.restoreLayerValue == "" ? "yandex" : sets.restoreLayerValue;
            console.log("restoring layer: " + rlayer);
            this.changeLayer(rlayer);
        }
        if (sets.restorePosition) {
            console.log("restoring position, zoom: " + sets.restorePositionZoom);

            if (!isNaN(sets.restorePositionZoom) && sets.restorePositionZoom != "") {
                this.$.map.setZoom(sets.restorePositionZoom);
                this.updateZoomLabel(sets.restorePositionZoom);
            }

            console.log("restoring position, location: " + sets.restorePositionLat + "/" + sets.restorePositionLong);

            if (!isNaN(sets.restorePositionLat))
                this.$.map.setCenter(sets.restorePositionLat, sets.restorePositionLong);
        }
        if (sets.disableScreenLock) {
            // disable screen lock
            window.PalmSystem.setWindowProperties({ blockScreenTimeout: true });
        }
        if (sets.restoreTrafficSelection) {
            console.log("restoring traffic: " + sets.restoreTrafficValue);
            this.updateTrafficControls();
        }

        this.settingsLoaded = true;
        this.showMap();
    },

    // ======================================= MAP Events ==========================================================

    listSetupRow: function (inSender, inRow) {
        var c = this.menuItems && this.menuItems[inRow];
        if (c) {
            this.$.name.setContent(c.name);
            this.$.btnOn.setChecked(false);

            if (c.id == this.layerSelected)
                this.$.btnOn.setChecked(true);

            return true;
        }
    },
    slidingResize: function (inSender, inRow) {
        this.$.map.resizeMap();
        this.adjustControls();
    },
    itemClick: function (inSender, inEvent) {
        var c = this.menuItems[inEvent.rowIndex];
        if (c.id == "yandex" || c.id == "google" || c.id == "osm") {
            this.changeLayer(c.id);
        }
    },

    changeLayer: function (sid) {
        console.log("change layer: " + sid);
        this.$.map.changeLayer(sid);
        this.layerSelected = sid;

        var settings = this.getSettings();
        if (settings.restoreLayerSelection && settings.restoreLayerValue !== sid) {
            settings.restoreLayerValue = sid;
            settings.save();
        }
        this.$.list.refresh();
    },

    buttonToggleTraffic: function (inSender, inState) {
        this.btnTrafficClick();
    },

    doToggleTraffic: function () {
        if (this.$.map.shownTraffic) {
            this.$.map.hideTraffic();
            this.$.roadEvents.hide();
        }
        else {
            this.$.map.showTraffic();
            this.$.roadEvents.show();
        }

        var settings = this.getSettings();
        if (settings.restoreTrafficSelection && settings.restoreTrafficValue !== this.$.map.shownTraffic) {
            settings.restoreTrafficValue = this.$.map.shownTraffic;
            settings.save();
        }
    },

    buttonToggleAccidents: function (inSender, inState) {
        if (this.$.map.shownAccidents)
            this.$.map.hideRoadEvents();
        else
            this.$.map.showRoadEvents();
    },

    // ================================ Gesture Handlers ====================================================
    gesturestartHandler: function (inSender, e) {
        //enyo.log("gesturestartHandler started");
        this.previousScale = e.scale;
    },
    gesturechangeHandler: function (inSender, e) {
        //enyo.log("gesturechangeHandler started");
        var d = this.previousScale - e.scale;
        if (Math.abs(d) > 0.25) {
            var z = this.$.map.getZoom() + (d > 0 ? -1 : +1);
            this.$.map.setZoom(z);
            this.updateZoomLabel(z);
            this.previousScale = e.scale;

            var settings = this.getSettings();
            if (settings.restorePosition) {
                console.log('saving position [gesture], zoom: ' + z);
                settings.restorePositionZoom = z;
                settings.save();
            }
        }
    },
    gestureendHandler: function (inSender, e) {
        //enyo.log("gestureendHandler started");
    }
})
