﻿enyo.kind({
    name: "enyo.SettingsHelper",
    kind: enyo.Component,
    components: [
      {
          name: "getPreferences",
          kind: "PalmService",
          service: "palm://com.palm.systemservice/",
          method: "getPreferences",
          onSuccess: "getPreferencesSuccess",
          onFailure: "getPreferencesFailure"
      },
      {
          name: "setPreferences",
          kind: "PalmService",
          service: "palm://com.palm.systemservice/",
          method: "setPreferences",
          onSuccess: "setPreferencesSuccess",
          onFailure: "setPreferencesFailure"
      }
    ],

    published: {
        disableScreenLock: false,
        restoreLayerSelection: false,
        restoreLayerValue: false,
        restorePosition: false,
        restorePositionLat: "",
        restorePositionLong: "",
        restorePositionZoom: "",
        restoreTrafficSelection: false,
        restoreTrafficValue: false,
        restoreGpsSelection: false,
        selectedGpsType: "google",
        loaded: false
    },
    events: {
        onLoaded: ""
    },

    getPreferencesSuccess: function (inSender, inResponse) {
        console.log("preferences are loaded");
        if (inResponse.settings) {
            this.disableScreenLock = inResponse.settings.disableScreenLock;
            this.restoreLayerSelection = inResponse.settings.restoreLayerSelection;
            this.restoreLayerValue = inResponse.settings.restoreLayerValue;
            this.restorePosition = inResponse.settings.restorePosition;
            this.restorePositionLat = inResponse.settings.restorePositionLat;
            this.restorePositionLong = inResponse.settings.restorePositionLong;
            this.restorePositionZoom = inResponse.settings.restorePositionZoom;
            this.restoreTrafficSelection = inResponse.settings.restoreTrafficSelection;
            this.restoreTrafficValue = inResponse.settings.restoreTrafficValue;
            this.restoreGpsSelection = inResponse.settings.restoreGpsSelection;
            this.selectedGpsType = inResponse.settings.selectedGpsType;
        }
        this.loaded = true;
        this.doLoaded();
    },
    getPreferencesFailure: function (inSender, inResponse) {
        console.log("failed to load preferences");
    },
    setPreferencesSuccess: function (inSender, inResponse) {
        console.log("preferences are saved");
    },
    setPreferencesFailure: function (inSender, inResponse) {
        console.log("failed to save preferences");
    },

    save: function () {
        console.log("save preferences");
        var settings = new Object();
        settings.disableScreenLock = this.disableScreenLock;
        settings.restoreLayerSelection = this.restoreLayerSelection;
        settings.restoreLayerValue = this.restoreLayerValue;
        settings.restorePosition = this.restorePosition;
        settings.restorePositionLat = this.restorePositionLat;
        settings.restorePositionLong = this.restorePositionLong;
        console.log('saving pos: ' + settings.restorePositionLat + '/' + settings.restorePositionLong);
        settings.restorePositionZoom = this.restorePositionZoom;
        settings.restoreTrafficSelection = this.restoreTrafficSelection;
        settings.restoreTrafficValue = this.restoreTrafficValue;
        settings.restoreGpsSelection = this.restoreGpsSelection;
        settings.selectedGpsType = this.selectedGpsType;

        this.$.setPreferences.call({ "settings": settings });
    },
    load: function () {
        console.log("load preferences");
        this.loaded = false;
        this.$.getPreferences.call({ "keys": ["settings"] });
    }
})