﻿enyo.kind({
    name: "enyo.SettingsView",
    kind: enyo.VFlexBox,
    events: {
        onBack: "",
        onLoaded: ""
    },
    components: [
      { name: "settings", kind: "SettingsHelper", onLoaded: "onSettingsLoaded" },
      { kind: "PageHeader", components: [
          { name: "backButton", kind: "Button", content: "Back", onclick: "goBack" },
          { kind: enyo.VFlexBox, content: "Settings", align: "end", flex: 1 }
      ]
      },
      { kind: "Group", caption: "Common", components: [
          { kind: "HFlexBox", align: "center", style: "padding: 10px", components: [
              { content: "Disable lock screen while running", flex: 1 },
              { name: "lock", kind: "ToggleButton", onChange: "changeParameter" }
          ]
          },
          { kind: "HFlexBox", align: "center", style: "padding: 10px", components: [
              { content: "Restore layer selection on the next run", flex: 1 },
              { name: "layer", kind: "ToggleButton", onChange: "changeParameter" }
          ]
          },
          { kind: "HFlexBox", align: "center", style: "padding: 10px", components: [
              { content: "Restore my last position", flex: 1 },
              { name: "pos", kind: "ToggleButton", onChange: "changeParameter" }
          ]
          },
      ]
      },
      { kind: "Group", caption: "Traffic", components: [
          { kind: "HFlexBox", align: "center", style: "padding: 10px", components: [
              { content: "Restore traffic settings on the next run", flex: 1 },
              { name: "traffic", kind: "ToggleButton", onChange: "changeParameter" }
          ]
          },
      ]
      },
      { kind: "Group", caption: "GPS options", components: [
            { kind: "HFlexBox", align: "center", style: "padding: 10px", components: [
                { content: "Turn on GPS on start up", flex: 1 },
                { name: "gps", kind: "ToggleButton", onChange: "changeParameter" }
            ]
            },
            { kind: "RadioGroup", name: "gpsType", onclick: "changeParameter", value: "google",
                components: [
                        { caption: "Google Services", value: "google", selected: true },
                        { caption: "Internal GPS", value: "internal" },
                        { caption: "Bluetooth GPS", value: "external" }
                    ]
            },
      ]
      }
    ],

    parameter: "",
    parameterValue: "",

    rendered: function () {
        this.inherited(arguments);
        this.$.settings.load();
    },
    goBack: function () {
        this.doBack();
    },
    changeParameter: function (inSender, inState) {
        this.parameter = inSender.name;
        try {
            this.parameterValue = inSender.getState();
        }
        catch (e) {
        }

        switch (this.parameter) {
            case "lock":
                // enable/disable screen lock
                window.PalmSystem.setWindowProperties({ blockScreenTimeout: inSender.getState() });
                this.$.settings.disableScreenLock = this.parameterValue;
                break;
            case "layer":
                this.$.settings.restoreLayerSelection = this.parameterValue;
                break;
            case "pos":
                this.$.settings.restorePosition = this.parameterValue;
                break;
            case "traffic":
                this.$.settings.restoreTrafficSelection = this.parameterValue;
                break;
            case "gps":
                this.$.settings.restoreGpsSelection = this.parameterValue;
                break;
            case "gpsType":
                console.log('saving gpsType: ' + inSender.getValue());
                this.$.settings.selectedGpsType = inSender.getValue();
                break;
        }
        this.$.settings.save();
    },

    onSettingsLoaded: function (inSender, inResponse) {
        this.$.lock.setState(this.$.settings.disableScreenLock);
        this.$.layer.setState(this.$.settings.restoreLayerSelection);
        this.$.pos.setState(this.$.settings.restorePosition);
        this.$.traffic.setState(this.$.settings.restoreTrafficSelection);
        this.$.gps.setState(this.$.settings.restoreGpsSelection);

        console.log('loading gpsType: ' + this.$.settings.selectedGpsType);
        this.$.gpsType.setValue(this.$.settings.selectedGpsType);

        this.doLoaded();
    }
})