﻿enyo.kind({
    name: "enyo.SpeedMeter",
    kind: enyo.Control,
    components: [
        { name: "background", kind: "Image", src: "images/speed_bg.png", showing: false,
            className: "speed-bg", width: "80px", height: "40px"
        },
        { name: "label", content: "0", className: "speed-lb", showing: false }
    ],

    published: {
        value: "0"
    },

    create: function () {
        this.inherited(arguments);
        this.parent.resizeHandler = enyo.bind(this, this.resizeHandler);
    },

    show: function() {
        this.$.background.show();
        this.$.label.show();
    },

    hide: function() {
        this.$.background.hide();
        this.$.label.hide();
    },

    setValue: function(value) {
        var fmts = new enyo.g11n.Fmts();
	    this.value = fmts.getMeasurementSystem() === "metric"
                        ? (Math.round(value*3.6))         // km/h
                        : (Math.round(value*3.6/1.6));    // mph
        var mv = "-6px";
        if (this.value >= 10 && this.value < 20) mv = "-10px";
        if (this.value >= 20) mv = "-12px";
        if (this.value >= 100) mv = "-16px";
        this.$.label.applyStyle("margin-left", mv);
        this.$.label.setContent(this.value);
    },

    resizeHandler: function() {     
        var width = this.parent.hasNode().offsetWidth;
        this.$.background.applyStyle("left", (width / 2) + "px");
        this.$.label.applyStyle("left", (width / 2) + "px");
    },

});