﻿enyo.kind({
    name: "enyo.GoogleGPS",
    kind: enyo.Component,
    events: {
        onLocated: "",
        onFailed: ""
    },
    components: [
        {
            name: "getPosition",
            kind: "PalmService",
            service: "palm://com.palm.location/",
            method: "getCurrentPosition",
            onSuccess: "getPosSuccess",
            onFailure: "getPosFailure"
        },        
        {
            name: "startTracking",
            kind: "PalmService",
            service: "palm://com.palm.location/",
            method: "startTracking",
            onSuccess: "getPosSuccess",
            onFailure: "getPosFailure",
            subscribe: true
        },
        {
            name: "stopTracking",
            kind: "PalmService", 
            service: "palm://com.palm.location/",
            method: "stopTracking",
            onResponse: "getPosSuccess",
        },
    ],
    
    getPosition: function () {
        this.$.getPosition.call({});
    },

    startTracking: function () {
        this.$.startTracking.call({});
    },

    stopTracking: function() {
        this.$.startTracking.cancel();
    },

    getPosSuccess: function (inSender, inResponse) {
        enyo.log("getCurrentPosition success, results=" + enyo.json.stringify(inResponse));
        this.doLocated(inResponse);
    },
    getPosFailure: function (inSender, inResponse) {
        enyo.log("getCurrentPosition failure, results=" + enyo.json.stringify(inResponse));
        this.doFailed(inResponse);
    }
});